Summary: Creates an initial ramdisk image for preloading modules
Name: mkinitrd
Version: 6.0.93
Release: %mkrel 27
License: GPLv2+
URL: http://www.redhat.com/
Group: System/Kernel and hardware
Source0: mkinitrd-%{version}.tar.bz2
Source100: mkinitrd-sysconfig
#BEGINGIT
Patch101: Create-etc-blkid.patch
Patch102: Fix-regexp-usage-to-work-on-bash-3.2.patch
Patch103: Add-missing-closedir.patch
Patch104: Display-current-kernel-version-in-usage.patch
Patch105: Handle-root-devno-from-lilo.patch
Patch106: Include-driver-for-current-keyboard.patch
Patch107: Get-correct-module-when-rootfs-is-auto-in-fstab.patch
Patch108: Handle-gzip-compressed-modules.patch
Patch109: Fix-handling-return-value-of-dm_task_run.patch
Patch110: Enforce-loading-correct-disk-driver.patch
Patch111: Fix-detection-of-usb_storage-module.patch
Patch112: Fix-resolving-library-deps.patch
Patch113: Disable-selinux.patch
Patch114: Disable-network-support.patch
Patch115: Add-support-for-bootchartd.patch
Patch116: Disable-usb-by-default.patch
Patch117: Don-t-overflow-ppoll.patch
Patch118: Reset-counter-between-the-tree-traversals.patch
Patch119: Return-the-last-kernel-arg-with-given-name.patch
Patch120: Let-readlink-compute-the-absolute-path-for-us.patch
Patch121: Include-both-ahci-and-ata_piix.patch
Patch122: Source-sysconfig-later.patch
Patch123: Resume.patch
Patch124: Include-ide-modules.patch
Patch125: Allow-overriding-DSDT.patch
Patch126: scsi_alias.patch
Patch127: checkroot.patch
Patch128: hooks.patch
Patch129: Wait-only-for-needed-devices.patch
Patch130: kbd-is-in-usr.patch
Patch131: Handle-SYSFONTACM-8859-15.patch
Patch132: Restrict-udev-messages-to-handle.patch
Patch133: Fix-waiting-in-devices.patch
Patch134: Fix-dmraid-to-wait-for-needed-disks.patch
Patch135: no-longer-uses-daemonize-to-start-plymouth-upstream-.patch
Patch136: Add-drm-detection-if-module-is-not-loaded.patch
Patch137: devtmpfs-support.patch
Patch138: Workaround-issue-on-dmraid-10.patch
Patch139: Create-urandom-for-LVM.patch
Patch140: Detect-devtmpfs-support-at-boot-time.patch
Patch141: Improve-keyboard-drivers-detection.patch
Patch142: Always-emit-plymouth.patch
Patch143: Revert-Add-drm-detection-if-module-is-not-loaded.patch
Patch144: Add-drm-whitelist-handling.patch
Patch145: Add-drm-drivers-for-hardware-with-no-currently-loade.patch
Patch146: change-filelist-for-new-bootchart.patch
Patch147: Include-additionnal-hid-keyboard-drivers-57872.patch
Patch148: Include-crc32c-for-btrfs-51622.patch
Patch149: Fix-cciss-support-59077.patch
Patch150: Fix-nash-firmware-loading-see-53220.patch
Patch201: 0001-Do-not-load-KMS-drivers-when-booted-with-nokmsboot-o.patch
Patch202: 0002-Whitelist-nouveau-and-radeon-drivers.patch
Patch203: 0003-Fix-build-with-gcc4.6.patch
#Patch204: mkinitrd-usb-input-usbhid-only.patch
Patch205: mkinitrd-6.0.93-use-oom_score_adj.patch
Patch206: mkinitrd-6.0.93-xz-support.patch
Patch207: mkinitrd-6.0.93-link.patch
Patch208: mkinitrd-6.0.93-drop-proc-usb.patch
Patch209: mkinitrd-6.0.93-include-delete-keymap.patch
Patch210: mkinitrd-6.0.93-nash-handle-nvme-drives.patch
Patch211: mkinitrd-6.0.93-no-delay.patch
Patch212: mkinitrd-6.0.93-fix-for-updated-glibc.patch
Patch213: mkinitrd-6.0.93-add-f2fs-support.patch
Patch214: mkinitrd-6.0.93-fix-copy-errors.patch
Patch215: mkinitrd-6.0.93-kbd-boot.patch
Patch216: mkinitrd-6.0.93-kmod.patch
Patch217: mkinitrd-6.0.93-functions.patch
Patch218: mkinitrd-6.0.93-ship-devmodules.patch

Requires: util-linux-ng
Requires: mktemp findutils
Requires: grep, mount gzip tar
Requires: filesystem cpio, initscripts
Requires: e2fsprogs coreutils
Requires: module-init-tools
Requires: kpartx diffutils
BuildRequires: popt-devel
BuildRequires: libblkid-devel parted-devel pkgconfig 
BuildRequires: device-mapper-devel python-devel
BuildRequires: python util-linux-ng
BuildRequires: elfutils-devel
Requires: nash = %{version}-%{release}
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

%description
mkinitrd creates filesystem images for use as initial ram filesystem
(initramfs) images.  These images are used to find and mount the root
filesystem.

%package devel
Summary: C header files and library for functionality exported by libnash
Group: Development/Libraries
Requires: glibc-devel, pkgconfig, e2fsprogs-devel, mkinitrd
Requires: nash = %{version}-%{release}

%package -n libbdevid-python
Summary: Python bindings for libbdevid
Group: Development/Other
Requires: python >= 2.7
Requires: nash = %{version}-%{release}

%package -n nash
Summary: Nash shell
Group: System/Kernel and hardware
Provides: libbdevid = %{version}-%{release}
Obsoletes: libbdevid < %{version}-%{release}

%description devel
C header files and library for functionality exported by libnash

%description -n libbdevid-python
Python bindings for libbdevid.

%description -n nash
nash shell used by initrd

%prep
%setup -q

%apply_patches

find . -name "Makefile*" -exec sed -i 's|-Werror||g' {} \;

%build
%define _disable_ld_no_undefined 1
export CFLAGS="%optflags -std=c99 -fPIC -D_GNU_SOURCE=1 -Wno-unused-result -Wno-implicit-function-declaration -Wno-format-overflow -Wno-free-nonheap-object"
export LDFLAGS="%ldflags -Wl,--wrap,open,--wrap,fopen,--wrap,opendir,--wrap,socket -Wl,--wrap,pipe,--wrap,mkdir,--wrap,access"
%setup_compile_flags
make LIB=%{_lib}
make LIB=%{_lib} test

%install
rm -rf $RPM_BUILD_ROOT
make LIB=%{_lib} DESTDIR=$RPM_BUILD_ROOT mandir=%{_mandir} install
rm -f $RPM_BUILD_ROOT/sbin/bdevid $RPM_BUILD_ROOT/%{_includedir}/blkent.h

# Mandriva
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig
install -m 644 %{SOURCE100} $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/mkinitrd

rm -f $RPM_BUILD_ROOT/sbin/installkernel
rm -f $RPM_BUILD_ROOT/usr/libexec/mkliveinitrd

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%attr(755,root,root) /sbin/mkinitrd
%attr(644,root,root) %{_mandir}/man8/mkinitrd.8*
%config(noreplace) %{_sysconfdir}/sysconfig/mkinitrd
/usr/libexec/initrd-functions

%files devel
%defattr(-,root,root)
%{_libdir}/libnash.so
%{_libdir}/libbdevid.so
%{_libdir}/libbdevidprobe.a
%{_libdir}/pkgconfig/libnash.pc
%{_libdir}/pkgconfig/libbdevid.pc
%{_libdir}/pkgconfig/libbdevidprobe.pc
%{_includedir}/nash.h
%{_includedir}/nash
%{_includedir}/bdevid.h
%{_includedir}/bdevid

%files -n libbdevid-python
%{python_sitearch}/bdevid.so

%files -n nash
%defattr(-,root,root)
%attr(644,root,root) %{_mandir}/man8/nash.8*
%attr(755,root,root) /sbin/nash
%attr(755,root,root) /sbin/lsinitrd
/%{_lib}/bdevid
%{_libdir}/libnash.so.*
%{_libdir}/libbdevid.so.*


%changelog
* Tue Oct 14 2022 yodelu - 6.0.93-27pclos2022
- Always ship device modules to initrd as 
  mknod need'em  when do the static-nodes 

* Tue Oct 11 2022 yodelu - 6.0.93-26pclos2022
- fix include softdeps in initramfs for loop deps (eg vfio) > rediff p217

* Thu Feb 24 2022 yodelu - 6.0.93.-25pclos2022
- fix annoying and useless null output(s) of redirects 2>/dev/null - rediff p217
- silent the compiler warnings -Wno-xxxxxxxxxxxxx
  
* Sat Feb 19 2022 yodelu - 6.0.93.-24pclos2022
- rediff p216
  > respect new depmod(kmod) rquirements 
  > modprobe doesn't like /dev/null - fixed

* Mon Dec 19 2021 tex - 6.0.93.-23pclos2021
- fix /usr/libexec/initrd-functions with
- mkinitrd-6.0.93-functions.patch

* Thu Dec 16 2021 yodelu 6.0.93-22pclos2021
rediff p216
 > revert DRM_WHITELIST as 
    - plymouth require modesetting to be enabled for nvidia
    - need more work to do on plymouth
    
* Sun Dec 12 2021 yodelu 6.0.93-21pclos2021
add p216
    > probe GPU on early boot -required for plymouth
    > start plymouth as needed (after probe GPU)
    > ready for kmod
    
* Wed Jan 27 2021 yodelu 6.0.93-20pclos2021
- fix build on gcc 11 (rediff p207)
- fix an annoying boot message (gzip cannot allocate memory)
    > map(s) needs to be uncompressed in initrd (add p215)

* Wed Jan 27 2021 TerryN <terryn94 at gmail.com> 6.0.93-20pclos2021
- fix spurious copy errors

* Tue Jan 26 2021 tex - 6.0.93-19pclos2021
- add f2fs support patch

* Fri Feb 07 2020 TerryN <terryn94 at gmail.com> 6.0.93-18pclos2020
- fix for extra trace output with glibc 2.31

* Sat Aug 18 2018 TerryN <terryn94 at gmail.com> 6.0.93-17pclos2018
- fix nash for eMMC drives too 

* Thu Feb 01 2018 bb2 <bb2> - 6.0.93-16pclos2018
- adjust no-delay patch

* Sat Jan 27 2018 bb2 <bb2> 6.0.93-15pclos2018
- add no-delay patch

* Tue Jan 23 2018 TerryN <terryn94 at gmail.com> 6.0.93-14pclos2018
- fix nash to handle NVME drives

* Thu Mar 12 2015 TerryN <terryn94 at gmail.com> 6.0.93-13pclos2015
- include delete keymap

* Tue Feb 11 2014 bb <bb> 6.0.93-12pclos2014
- change patch to /sbin/plymouthd --attach-to-session

* Sun Dec 08 2013 billybot <billybot> 6.0.93-11pclos2013
- drop depcreciated mount -t usbfs /proc/bus/usb /proc/bus/usb
 
* Tue Aug 20 2013 billybot <billybot> 6.0.93-10pclos2013
- remove patch 204 as it breaks the esc key during boot splash

* Thu Aug 15 2013 billybot <billybot> 6.0.93-9pclos2013
- update python 2.7

* Tue Jun 07 2011 Texstar <texstar at gmail.com> 6.0.93-8pclos2011
- sync to mdv/mageia for 2011 release
- do not load kms drivers when booted with nokmsboot or failsafe options
- whitelist nouveau and radeon drivers for putting into initrd

* Sun Sep 05 2010 Texstar <texstar at gmail.com> 6.0.93-7pclos2010
- rebuild new python

* Sat May 29 2010 pcserver <pcserver at hush.com> 6.0.93-6pclos2010
- sync to mdv

* Tue May 18 2010 Texstar <texstar at gmail.com> 6.0.93-5pclos2010
- sync to mdv

* Sun Apr 04 2010 Johnny Black <johnnyblack at inbox.com> 6.0.93-4pclos2010
- rebuild for new parted

* Sun Jan 10 2010 Texstar <texstar at gmail.com> 6.0.93-3pclos2010
- update
- trim specfile

